package 
{
    import flash.display.Bitmap;
    import flash.display.BitmapData;
	import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
	import flash.events.Event;
    import flash.geom.Matrix;
    import flash.geom.Rectangle;
    import objects.Circle;
    import utils.Stats;
	
	/**
	 * ...
	 * @author Grigoriev Nikita
	 */
	public class Main extends Sprite 
	{
        private static const N:int = 5000;
        
		private var bitmapData:BitmapData;
        private var bitmap:Bitmap;
        private var rectangle:Rectangle = new Rectangle();
        private var circles:Vector.<Circle> = new Vector.<Circle>();
        
        public static var stageWidth:Number;
		public static var stageHeight:Number;
        
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, addedToStageListener);
		}
        
        private function addedToStageListener(e:Event):void 
        {
            removeEventListener(Event.ADDED_TO_STAGE, addedToStageListener);
            init();
        }
		
		private function init():void 
		{
            setStageParameters();
            createBitmap()
            createCircles();
            addChild(new Stats());
			addEventListener(Event.ENTER_FRAME, enterFrameListener);
		}
        
        private function setStageParameters():void 
        {
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.addEventListener(Event.RESIZE, resizeListener);
        }
        
        private function resizeListener(e:Event):void 
        {
            removeChild(bitmap);
            createBitmap();
        }
        
        private function createBitmap():void 
        {
            stageWidth = stage.stageWidth;
			stageHeight = stage.stageHeight;
			bitmapData = new BitmapData(stageWidth, stageHeight, true, 0x00000000);
			bitmap = new Bitmap(bitmapData);
			rectangle.width = stageWidth;
			rectangle.height = stageHeight;
			addChild(bitmap);
        }
        
        private function createCircles():void 
        {
            for (var i:int = 0; i < N; i++) 
			{
				var circle:Circle = new Circle();
				circles.push(circle);
			}
        }
        
        private function enterFrameListener(e:Event):void 
        {
            bitmapData.lock();
            bitmapData.fillRect(rectangle, 0x00000000);
            for (var i:int = 0; i < N; i++) 
			{
				var circle:Circle = circles[i];
				circle.move();
				bitmapData.copyPixels(circle.bitmapData, circle.rectangle, circle.point, null, null, true);
                //var matrix:Matrix = new Matrix(1, 0, 0, 1, circle.point.x, circle.point.y);
				//bitmapData.draw(circle.bitmapData, matrix, null, null, null, true);
			}
            bitmapData.unlock();
        }
	}
}