package objects 
{
    import flash.display.BitmapData;
    import flash.display.Graphics;
    import flash.display.Shape;
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import utils.XORRandom;
	/**
     * ...
     * @author Grigoriev Nikita
     */
    public class Circle
    {
        private static const MIN_RADIUS:int = 1;
        private static const MAX_RIADIUS:int = 10;
        
        private static const MIN_SPEED:int = 1;
        private static const MAX_SPEED:int = 5;
        
        private static const RIGHT:int = 0;
        private static const LEFT:int = 1;
        private static const UP:int = 2;
        private static const DOWN:int = 3;
        
        private static const PADDING:int = 80;
        
        // Данные для отрисовки в BitmapData
        public var bitmapData:BitmapData;
        public var rectangle:Rectangle;
        public var point:Point = new Point();
        
        private var destination:Point = new Point();
        private var stepX:Number;
        private var stepY:Number;
        
        public function Circle() 
        {
            init();
        }
        
        private function init():void 
        {
            var radius:int = XORRandom.randomRangeInt(MIN_RADIUS, MAX_RIADIUS);
            var size:int = radius * 2;
            var shape:Shape = getCircle(radius);
            bitmapData = new BitmapData(size, size, true, 0);
			bitmapData.draw(shape);
			rectangle = new Rectangle(0, 0, size, size);
            setPosition(point);
            setNewDestination();
        }
        
        private function getCircle(radius:int):Shape
        {
            var circle:Shape = new Shape();
            var graphics:Graphics = circle.graphics;
            graphics.beginFill(randomColor);
            graphics.drawCircle(radius, radius, radius);
            graphics.endFill();
			return circle;
        }
        
        private function get randomColor():uint
		{
			return XORRandom.random * 0x1000000;
		}
        
        private function setNewDestination():void 
        {
            setPosition(destination);
            calculateStep();
        }
        
        private function setPosition(point:Point):void 
        {
            var direction:int = XORRandom.randomRangeInt(0, 3);
            if (direction == LEFT)
            {
                point.x = -PADDING;
                point.y = XORRandom.random * Main.stageHeight;
            }
            if (direction == RIGHT)
            {
                point.x = Main.stageWidth + PADDING;
                point.y = XORRandom.random * Main.stageHeight;
            }
            if (direction == UP)
            {
                point.x = XORRandom.random * Main.stageWidth;
                point.y = -PADDING;
            }
            if (direction == DOWN)
            {
                point.x = XORRandom.random * Main.stageWidth;
                point.y = Main.stageHeight + PADDING;
            }
        }
        
        private function calculateStep():void 
        {
			var speed:Number = XORRandom.randomRangeNumber(MIN_SPEED, MAX_SPEED);
			var distantion:Number = Point.distance(point, destination);
			var numSteps:int = int(distantion / speed);
			var distantionX:Number = destination.x - point.x;
			var distantionY:Number = destination.y - point.y;
			
			stepX = distantionX / numSteps;
			stepY = distantionY / numSteps;
        }
        
        public function move():void
        {
            if (Point.distance(point, destination) < MAX_RIADIUS) 
                setNewDestination();
            point.x += stepX;
            point.y += stepY;
        }
    }
}